package Shiori;
use utf8;

# VARIABLE
our $system = {
	ghostname => 'Shiolink/Perl Simple Ghost',
	version => '1.0',
	craftman => 'Narazaka',
	craftmanw => '奈良阪某',
	shioriid => 'Shiolink_Perl_Simple',
	name => 'Shiolink/Perl Simple'
};

# CONSTANT
my $shiolink_responce = {
	L => \&load,
	S => \&request,
	U => \&unload
};
my $shiolink_types = join '|',keys %$shiolink_responce;
my $shiolink_regexp = qr/^\*($shiolink_types):(.*)/;
my $statusstring = {
	200 => 'OK',
	204 => 'No Content',
	311 => 'Not Enough',
	312 => 'Advice',
	400 => 'Bad Request',
	500 => 'Internal Server Error'
};

# MAIN LOOP
sub println;

sub mainloop{
	::init() if defined &::init;
	my @requests;
	while(<STDIN>){
		chomp;
		if(my ($name,$value) = /$shiolink_regexp/){
			$shiolink_responce->{$name}->($name,$value);
		}
	}
	::end() if defined &::end;
}

# MAIN ROUTINES
sub parse;
sub callback;
sub responce;

sub load{
	$system->{loaddir} = (shift,shift)[1];
}

sub unload{
	exit;
}

sub request{
	println '*' . shift . ':' . shift;
	my @requests;
	while(<STDIN>){
		chomp;
		if($_){
			push @requests,$_;
		}else{
			my ($method,$type,$version,$request,$statuscode,$responce);
			($method,$type,$version,$request) = parse @requests;
			($type,$version,$statuscode,$responce) = callback $method,$type,$version,$request;
			responce $type,$version,$statuscode,$responce;
			last;
		}
	}
}

# SUB ROUTINES
sub println{
	print STDOUT @_,"\n";
}

sub parse{
	my $commandline = shift;
	my @requestheaders = @_;
	my ($method,$type,$version) = $commandline =~ m@^(.*) (SHIORI|SAORI)/(.*)@;
	$version = '3.0'; # 3.0で常に通信する 古い処理系(materia等)で一部イベント動かないときあるかも
	my $request;
	$request->{$_->[0]} = $_->[1] for map {[/^(.+?): (.*)$/]} @requestheaders;
	return $method,$type,$version,$request;
}

sub callback{
	my $method = shift;
	my $type = shift;
	my $version = shift;
	my $request = shift;
	my $statuscode = 204;
	my $responce = {};
	my $id = $request->{ID};
	$id =~ s/\./_/g;
	if($method eq 'GET'){
		my ($value,$headers);
		($value,$statuscode,$headers) = *{'::'.$id}->($request,$type) if defined *{'::'.$id} || defined *{'::AUTOLOAD'};
		$responce->{Value} = $value;
		$responce->{Value} =~ s/[\n\r]//g;
		if(ref $headers){ # for OnCommunicate etc.
			$responce->{$_} = $headers->{$_} for keys %$headers;
		}
		if(!$responce->{Value}){
			if($request->{ID} eq 'version'){
				$responce->{Value} = $system->{version};
			}elsif($request->{ID} eq 'craftman'){
				$responce->{Value} = $system->{craftman};
			}elsif($request->{ID} eq 'craftmanw'){
				$responce->{Value} = $system->{craftmanw};
			}elsif($request->{ID} eq 'shioriid'){
				$responce->{Value} = $system->{shioriid};
			}elsif($request->{ID} eq 'name'){
				$responce->{Value} = $system->{name};
			}
		}
		$statuscode = $responce->{Value} ? 200 : 204 unless $statuscode;
	}elsif($method eq 'NOTIFY'){
		$system->{ghostname} = $request->{Reference0} if $id eq 'ownerghostname';
		*{'::'.$id}->($request,$type) if defined *{'::'.$id};
		$statuscode = 204;
	}
	$responce->{Charset} = 'UTF-8';
	$responce->{Sender} = $system->{ghostname};
	return $type,$version,$statuscode,$responce;
}

sub responce{
	my $type = shift;
	my $version = shift;
	my $statuscode = shift;
	my $responce = shift;
	println $type,'/',$version,' ',$statuscode,' ',$statusstring->{$statuscode};
	println $_,': ',$responce->{$_} for keys %$responce;
	println '';
}

1;
